/*******************************************************************************
 * FoxGameObject_Bomb generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameObject_Bomb extends FoxGameObject_Carry
    abstract
    transient
    native
    config(Game)
    notplaceable
    hidecategories(Navigation);

var repnotify transient bool bIsPlanted;
var repnotify transient bool bIsExploded;
var repnotify transient bool bIsDefused;
var repnotify transient bool bBombIsPickedUp;
var transient FoxGameObject_BombTarget PlantedTarget;
var transient FoxPRI Planter;
var transient FoxPawn DropperPawn;
var const transient int DefuseRadiusSquared;
var AkEvent PickupBombAkEvent;
var AkEvent PlantBombLoop;
var const float BombRampTime;
var AkEvent PlantBombLoopRamp;
var AkEvent StopBombLoopRamp;
var AkEvent DefuseBombAkEvent;
var AkEvent BombExplodeAkEvent;
var class<FoxWeapon_SNDBombBase> BombWeaponClass;
var ParticleSystem ExplosionFX;
var Emitter ExplosionEmitter;
var() export editinline ParticleSystemComponent BlinkingPSC;
var() export editinline ParticleSystemComponent JammerPSC;
var const name BlinkingSocketName;
var const name BlinkingColorName;
var export editinline array<export editinline MaterialInstanceConstant> BombMIC;
var const name BombMICColorName;
var const config float BombInactiveRespawnTime;
var const config float CloakRadius;
var float CloakRadiusSquared;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        PlantedTarget, bBombIsPickedUp, 
        bIsDefused, bIsExploded, 
        bIsPlanted
}

simulated event PostBeginPlay()
{
    super.PostBeginPlay();
    // End:0x59
    if(Role == ROLE_Authority)
    {
        SpawnLocation = ObjectMesh.Bounds.Origin;
    }
    // End:0xC4
    if(FoxGRI_SND(WorldInfo.GRI) != none)
    {
        FoxGRI_SND(WorldInfo.GRI).BombObject = self;
    }
    SkeletalMeshComponent(ObjectMesh).AttachComponentToSocket(BlinkingPSC, BlinkingSocketName);
    CloakRadiusSquared = CloakRadius * CloakRadius;
    // End:0x183
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        BlinkingPSC.DeactivateSystem();
        JammerPSC.DeactivateSystem();
    }
    SetEmissives();
    //return;    
}

simulated function SetEmissives()
{
    local int I;
    local LinearColor EmissiveColor;

    // End:0x35
    if(WorldInfo.NetMode == NM_DedicatedServer)
    {
        super.SetEmissives();
        return;
    }
    // End:0xAA
    if(BlinkingPSC != none)
    {
        BlinkingPSC.SetColorParameter(BlinkingColorName, FoxGRI(WorldInfo.GRI).GetColorForTeam(self));
    }
    // End:0x101
    if(!bIsDefused)
    {
        EmissiveColor = FoxGRI(WorldInfo.GRI).GetEmissiveColorForTeam(self);
    }
    I = 0;
    J0x10C:
    // End:0x1D6 [Loop If]
    if(I < ObjectMesh.GetNumElements())
    {
        // End:0x18D
        if(I >= BombMIC.Length)
        {
            BombMIC[I] = ObjectMesh.CreateAndSetMaterialInstanceConstant(I);
        }
        BombMIC[I].SetVectorParameterValue(BombMICColorName, EmissiveColor);
        ++ I;
        // [Loop Continue]
        goto J0x10C;
    }
    // End:0x291
    if(((CarriedByPawn != none) && FoxGRI(WorldInfo.GRI).IsActorFriendlyToLocalPlayer(self)) && !FoxGRI(WorldInfo.GRI).IsMutatorEnabled(4))
    {
        JammerPSC.SetHidden(false);
    }
    // End:0x2B1
    else
    {
        JammerPSC.SetHidden(true);
    }
    //return;    
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x3E
    if(VarName == 'bIsPlanted')
    {
        // End:0x31
        if(bIsPlanted)
        {
            OnBombPlanted();
        }
        // End:0x3B
        else
        {
            OnRoundEnd();
        }
    }
    // End:0xF1
    else
    {
        // End:0x6F
        if(VarName == 'bIsExploded')
        {
            // End:0x6C
            if(bIsExploded)
            {
                ExplodeBombFX();
            }
        }
        // End:0xF1
        else
        {
            // End:0xA0
            if(VarName == 'bIsDefused')
            {
                // End:0x9D
                if(bIsDefused)
                {
                    OnBombDefused();
                }
            }
            // End:0xF1
            else
            {
                // End:0xDE
                if(VarName == 'bBombIsPickedUp')
                {
                    // End:0xD1
                    if(bBombIsPickedUp)
                    {
                        OnPickup();
                    }
                    // End:0xDB
                    else
                    {
                        OnDrop();
                    }
                }
                // End:0xF1
                else
                {
                    super.ReplicatedEvent(VarName);
                }
            }
        }
    }
    //return;    
}

// Export UFoxGameObject_Bomb::execCanInteractWith(FFrame&, void* const)
native simulated function bool CanInteractWith(FoxPawn InteractingPawn);

event Touch(Actor Other, PrimitiveComponent OtherComp, Vector HitLocation, Vector HitNormal)
{
    local FoxPawn TouchedPawn;

    TouchedPawn = FoxPawn(Other);
    // End:0x1CF
    if((((((((((bScriptInitialized && WorldInfo.Game != none) && FoxGameMP_SND(WorldInfo.Game) != none) && FoxGameMP_SND(WorldInfo.Game).PendingBombPickupPlayer == none) && !bIsPlanted) && TouchedPawn != none) && CarriedByPawn == none) && TouchedPawn.PlayerReplicationInfo != none) && FoxPRI(TouchedPawn.PlayerReplicationInfo).IsValidPlayer()) && TouchedPawn.GetTeamNum() == class'FoxGameMP_SND'.default.AttackingTeamIndex) && TouchedPawn != DropperPawn)
    {
        Pickup(TouchedPawn);
    }
    //return;    
}

event UnTouch(Actor Other)
{
    local FoxPawn UntouchedPawn;

    UntouchedPawn = FoxPawn(Other);
    // End:0x4F
    if((UntouchedPawn != none) && UntouchedPawn == DropperPawn)
    {
        DropperPawn = none;
    }
    //return;    
}

simulated function Pickup(FoxPawn PickedUpPawn)
{
    local FoxPawn OriginalCarriedByPawn;

    OriginalCarriedByPawn = CarriedByPawn;
    super.Pickup(PickedUpPawn);
    // End:0x158
    if(((Role == ROLE_Authority) && PickedUpPawn != none) && OriginalCarriedByPawn == none)
    {
        // End:0xEE
        if(FoxGameMP_SND(WorldInfo.Game) != none)
        {
            FoxGameMP_SND(WorldInfo.Game).BombPickedUp(self, FoxPRI(PickedUpPawn.PlayerReplicationInfo));
        }
        PickedUpPawn.bCarryingObject = true;
        PickedUpPawn.AddInventory(BombWeaponClass);
        PlayAkEvent(PickupBombAkEvent,,,, Location);
    }
    // End:0x1EA
    if(!PickedUpPawn.GearInfo.bFemale)
    {
        ObjectMesh.SetRotation(rot(32768, 16384, 0));
        ObjectMesh.SetTranslation(vect(0.0, 0.0, 4.0));
    }
    // End:0x216
    else
    {
        ObjectMesh.SetRotation(rot(16384, 0, 16384));
    }
    // End:0x319
    if((((FoxGame(WorldInfo.Game) != none) && !FoxGame(WorldInfo.Game).bPendingRoundEnd) && !FoxGRI(WorldInfo.GRI).bMatchIsOver) && !FoxGRI_SND(WorldInfo.GRI).bSpawnFreeze)
    {
        OnPickup();
    }
    SetEmissives();
    // End:0x35C
    if((PickedUpPawn != none) && Role == ROLE_Authority)
    {
        ClearTimer('OnBombInactiveRespawn');
    }
    JammerPSC.DetachFromAny();
    JammerPSC.SetTranslation(vect(0.0, 0.0, -48.0));
    PickedUpPawn.AttachComponent(JammerPSC);
    //return;    
}

simulated function Drop()
{
    local Vector MeshOffset;

    // End:0x35
    if(Role == ROLE_Authority)
    {
        CarriedByPawn.bCarryingObject = false;
    }
    DropperPawn = CarriedByPawn;
    ObjectMesh.SetRotation(rot(0, 0, 0));
    ObjectMesh.SetTranslation(MeshOffset);
    // End:0x16C
    if((((FoxGame(WorldInfo.Game) != none) && !FoxGame(WorldInfo.Game).bPendingRoundEnd) && !FoxGRI(WorldInfo.GRI).bMatchIsOver) && !bIsPlanted)
    {
        OnDrop();
    }
    // End:0x197
    if(Role == ROLE_Authority)
    {
        SetTimer(BombInactiveRespawnTime, false, 'OnBombInactiveRespawn');
    }
    JammerPSC.DetachFromAny();
    JammerPSC.SetTranslation(vect(0.0, 0.0, 0.0));
    AttachComponent(JammerPSC);
    super.Drop();
    //return;    
}

function PlantBomb()
{
    bIsPlanted = true;
    Drop();
    OnBombPlanted();
    //return;    
}

simulated function OnBombPlanted()
{
    local float BombTime;

    BombTime = float(FoxGRI_SND(WorldInfo.GRI).BombAliveTime);
    // End:0xC8
    if((Role == ROLE_Authority) && FoxGRI_SND(WorldInfo.GRI) != none)
    {
        FoxGRI_SND(WorldInfo.GRI).StartBombTimer();
    }
    // End:0xF6
    if(BombTime <= BombRampTime)
    {
        PostAkEvent(PlantBombLoopRamp);
    }
    // End:0x12C
    else
    {
        PostAkEvent(PlantBombLoop);
        SetTimer(BombTime - BombRampTime, false, 'RampBombAudio');
    }
    // End:0x1B5
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        BlinkingPSC.SetActive(true);
        FoxGRI_SND(WorldInfo.GRI).GameObjectiveDialog(59);
    }
    //return;    
}

simulated function OnRoundEnd()
{
    bIsPlanted = false;
    PostAkEvent(StopBombLoopRamp);
    ClearTimer('RampBombAudio');
    ClearTimer('NotifyBombExplode');
    //return;    
}

simulated function RampBombAudio()
{
    PostAkEvent(PlantBombLoopRamp);
    //return;    
}

function NotifyBombExplode()
{
    // End:0xB6
    if(FoxGameMP_SND(WorldInfo.Game) != none)
    {
        FoxGameMP_SND(WorldInfo.Game).NotifyBombExplode();
        // End:0xB6
        if(Planter != none)
        {
            FoxOnlineStatsWriteGameTypeSND(Planter.GameTypeStats).IncrementBombExplodes();
        }
    }
    // End:0x102
    if(Role == ROLE_Authority)
    {
        ExplodeBombFX();
        HurtRadius(5000.0, 1024.0, class'FoxDamageType_Explosion', 10000.0, Location);
    }
    //return;    
}

simulated function ExplodeBombFX()
{
    bIsExploded = true;
    PostAkEvent(StopBombLoopRamp);
    PostAkEvent(BombExplodeAkEvent);
    ObjectMesh.SetHidden(true);
    BlinkingPSC.SetActive(false);
    // End:0x150
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        ExplosionEmitter = FoxGRI(WorldInfo.GRI).ObjectPool.GetEmitter(ExplosionFX, Location, rotator(vect(0.0, 0.0, 1.0)));
        ExplosionEmitter.ParticleSystemComponent.ActivateSystem();
    }
    //return;    
}

simulated function OnBombDefused()
{
    bIsDefused = true;
    PostAkEvent(StopBombLoopRamp);
    PostAkEvent(DefuseBombAkEvent);
    BlinkingPSC.SetHidden(true);
    SetEmissives();
    ClearTimer('RampBombAudio');
    ClearTimer('NotifyBombExplode');
    // End:0x106
    if((Role == ROLE_Authority) && FoxGRI_SND(WorldInfo.GRI) != none)
    {
        FoxGRI_SND(WorldInfo.GRI).NotifyBombDefused();
    }
    //return;    
}

function OnBombInactiveRespawn()
{
    // End:0x23
    if((CarriedByPawn == none) && !bIsPlanted)
    {
        Destroy();
    }
    //return;    
}

simulated event Destroyed()
{
    // End:0x7E
    if(Role == ROLE_Authority)
    {
        // End:0x7E
        if(FoxGameMP_SND(WorldInfo.Game) != none)
        {
            FoxGameMP_SND(WorldInfo.Game).BombDestroyed();
        }
    }
    // End:0xA5
    if(ExplosionEmitter != none)
    {
        ExplosionEmitter.Destroy();
    }
    BlinkingPSC.SetActive(false);
    super.Destroyed();
    //return;    
}

simulated event byte ScriptGetTeamNum()
{
    return 0;
    //return ReturnValue;    
}

simulated event ToggleHRVEffects(const bool bHRVEnabled)
{
    //return;    
}

simulated function OnDrop()
{
    bBombIsPickedUp = false;
    // End:0xB8
    if((WorldInfo.NetMode != NM_DedicatedServer) && !FoxGRI(WorldInfo.GRI).bRoundInTransition)
    {
        FoxGRI_SND(WorldInfo.GRI).GameObjectiveDialog(64);
    }
    //return;    
}

simulated function OnPickup()
{
    bBombIsPickedUp = true;
    // End:0x74
    if(WorldInfo.NetMode != NM_DedicatedServer)
    {
        FoxGRI_SND(WorldInfo.GRI).GameObjectiveDialog(62);
    }
    //return;    
}

// Export UFoxGameObject_Bomb::execIsPawnInRadius(FFrame&, void* const)
native simulated function bool IsPawnInRadius(FoxPawn inPawn);

// Export UFoxGameObject_Bomb::execCanPawnDefuse(FFrame&, void* const)
native simulated function bool CanPawnDefuse(FoxPawn inPawn);

defaultproperties
{
    bBombIsPickedUp=true
    DefuseRadiusSquared=40000
    BombRampTime=10.0
    begin object name=BlinkComponent0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_Bomb.BlinkComponent0'
    BlinkingPSC=BlinkComponent0
    begin object name=JammerComponent1 class=ParticleSystemComponent
        ReplacementPrimitive=none
        HiddenGame=true
        AbsoluteRotation=true
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_Bomb.JammerComponent1'
    JammerPSC=JammerComponent1
    BlinkingSocketName=S_Blink
    BlinkingColorName=Color
    BombMICColorName=Emis_Color
    BombInactiveRespawnTime=30.0
    CloakRadius=450.0
    begin object name=NewCylinder class=CylinderComponent
        ReplacementPrimitive=none
        Translation=(X=0.0,Y=0.0,Z=0.0)
    object end
    // Reference: CylinderComponent'Default__FoxGameObject_Bomb.NewCylinder'
    ObjectCylinder=NewCylinder
    begin object name=BombMesh class=SkeletalMeshComponent
        bUpdateSkelWhenNotRendered=false
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_Bomb.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_Nothing
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_Bomb.BombMesh'
    ObjectMesh=BombMesh
    begin object name=NewCylinder class=CylinderComponent
        ReplacementPrimitive=none
        Translation=(X=0.0,Y=0.0,Z=0.0)
    object end
    // Reference: CylinderComponent'Default__FoxGameObject_Bomb.NewCylinder'
    Components(0)=NewCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxGameObject_Bomb.MyLightEnvironment'
    begin object name=BombMesh class=SkeletalMeshComponent
        bUpdateSkelWhenNotRendered=false
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_Bomb.MyLightEnvironment'
        RBChannel=ERBCollisionChannel.RBCC_Nothing
    object end
    // Reference: SkeletalMeshComponent'Default__FoxGameObject_Bomb.BombMesh'
    Components(2)=BombMesh
    begin object name=BlinkComponent0 class=ParticleSystemComponent
        bAutoActivate=false
        ReplacementPrimitive=none
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_Bomb.BlinkComponent0'
    Components(3)=BlinkComponent0
    begin object name=JammerComponent1 class=ParticleSystemComponent
        ReplacementPrimitive=none
        HiddenGame=true
        AbsoluteRotation=true
    object end
    // Reference: ParticleSystemComponent'Default__FoxGameObject_Bomb.JammerComponent1'
    Components(4)=JammerComponent1
    bPostRenderIfNotVisible=true
    begin object name=NewCylinder class=CylinderComponent
        ReplacementPrimitive=none
        Translation=(X=0.0,Y=0.0,Z=0.0)
    object end
    // Reference: CylinderComponent'Default__FoxGameObject_Bomb.NewCylinder'
    CollisionComponent=NewCylinder
}